﻿<Graph ClassName="ExpenseClaimEntryExtChangeGL" Source="#CDATA" IsNew="True" FileType="NewGraph">
    <CDATA name="Source"><![CDATA[using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using PX.Common;
using PX.Data;
using PX.Objects.AP;
using PX.Objects.CA;
using PX.Objects.CM;
using PX.Objects.Common;
using PX.Objects.CR;
using PX.Objects.CS;
using PX.Objects.CT;
using PX.Objects.GL;
using PX.Objects.IN;
using PX.Objects.TX;
using PX.TM;
using PX.Objects.PM;
using PX.Objects.Common.Extensions;
using static PX.Objects.Common.UIState;
using PX.Objects.GL.FinPeriods;
using PX.Objects;
using PX.Objects.EP;

namespace PX.Objects.EP
{
    public class ExpenseClaimEntryExtChangeGL : PXGraphExtension<ExpenseClaimEntry>
    {
        public PXFilter<AccountSelect> AccountPopup;

        public PXAction<EPExpenseClaim> ChangeGL;
        [PXUIField(DisplayName = "Change Expense Accounts")]
        [PXButton]
        public virtual IEnumerable changeGL(PXAdapter adapter)
        {
            if (AccountPopup.AskExt() == WebDialogResult.OK)
            {
                PXLongOperation.StartOperation(Base, delegate ()
                {
                    var popup = AccountPopup.Current;
                    var currentReceipt = Base.ExpenseClaimDetails.Current;

                    Base.ExpenseClaimDetails.SetValueExt<EPExpenseClaimDetails.expenseAccountID>(currentReceipt, popup.ExpenseAccountID);
                    Base.ExpenseClaimDetails.SetValueExt<EPExpenseClaimDetails.expenseSubID>(currentReceipt, popup.ExpenseSubID);

                    Base.ExpenseClaimDetails.Update(currentReceipt);

                    Base.Persist();
                });
            }

            return adapter.Get();
        }

        public void EPExpenseClaim_RowSelected(PXCache cache, PXRowSelectedEventArgs e)
        {
            var row = (EPExpenseClaim)e.Row;
            if (row == null) return;

            ChangeGL.SetVisible(row.Approved == false && UserIsApprover());
        }

        public virtual bool UserIsApprover()
        {
            foreach (EPApproval approval in Base.Approval.Select())
            {
                if (approval.OwnerID != null)
                {
                    if (PXAccess.GetUserID() == approval.OwnerID)
                        return true;
                }
                else if (approval.WorkgroupID != null)
                {
                    EPCompanyTreeMember wg =
                    PXSelect<
                        EPCompanyTreeMember,
                        Where<
                        EPCompanyTreeMember.workGroupID, Equal<Required<EPCompanyTree.workGroupID>>,
                            And<EPCompanyTreeMember.userID, Equal<Current<AccessInfo.userID>>>>>
                        .Select(Base, approval.WorkgroupID);

                    if (wg != null)
                        return true;
                }

            }

            return false;
        }

        [Serializable]
        public class AccountSelect : IBqlTable
        {
            #region ExpenseAccountID

            public abstract class expenseAccountID : PX.Data.BQL.BqlInt.Field<expenseAccountID> { }
            [Account(DisplayName = "Expense Account", Visibility = PXUIVisibility.Visible, AvoidControlAccounts = true)]
            //[PXUIVerify(typeof(Where<Current2<EPExpenseClaimDetails.contractID>, IsNull,
            //                        Or<Current2<expenseAccountID>, IsNull,
            //                        Or<Selector<EPExpenseClaimDetails.contractID, Contract.nonProject>, Equal<True>,
            //                        Or<Selector<EPExpenseClaimDetails.contractID, Contract.baseType>, Equal<CTPRType.contract>,
            //                        Or<Selector<expenseAccountID, Account.accountGroupID>, IsNotNull>>>>>),
            //            PXErrorLevel.Error, Messages.AccountGroupIsNotAssignedForAccount, typeof(expenseAccountID))]//, account.AccountCD.Trim())]
            [PXDefault(typeof(EPExpenseClaimDetails.expenseAccountID))]
            public virtual int? ExpenseAccountID
            {
                get;
                set;
            }
            #endregion
            #region ExpenseSubID

            public abstract class expenseSubID : PX.Data.BQL.BqlInt.Field<expenseSubID> { }
            [SubAccount(typeof(EPExpenseClaimDetails.expenseAccountID), DisplayName = "Expense Sub.", Visibility = PXUIVisibility.Visible)]
            [PXDefault(typeof(EPExpenseClaimDetails.expenseSubID))]
            public virtual int? ExpenseSubID
            {
                get;
                set;
            }
            #endregion
        }
    }
}]]></CDATA>
</Graph>